/* 
* Rootfly:  A program for analyzing and measuring roots. 
* Copyright (c) 2005 Clemson University.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or (at
* your option) any later version.
* 
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

// RootOverTime.h: interface for the RootOverTime class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ROOTOVERTIME_H__EFF4561B_7FB1_4BE2_81CC_0C5B38CB9C96__INCLUDED_)
#define AFX_ROOTOVERTIME_H__EFF4561B_7FB1_4BE2_81CC_0C5B38CB9C96__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "stdafx.h"

// possible root colors
enum Color {COLOR_DARKBROWN,COLOR_LIGHTBROWN,COLOR_BLACK,COLOR_WHITE};
 
struct RootInstance
{
	std::vector<CPoint> points;		// vector multiple points line
	double diameter;						// root diameter
	Color color;							// root color
	CPoint diameter_center;				// center coordinate of a diameter
};

class RootOverTime
{
public:
   RootOverTime();
   virtual ~RootOverTime();
   RootInstance *GetRootInstance(int session, bool *still_live);
   RootInstance *CreateRootInstance(int session);
   void SetRootInstance(int session, RootInstance root);
   void DeclareDead(int session, bool dead=true, bool all_time=false);
   CPoint GetOffset(int session);
   void SetOffset(int session, CPoint offset);
   int GetNumInstances();
   int GetFirstSession();
   bool GetStatus();

private:
   std::vector<RootInstance> m_instances;
   std::vector<CPoint> m_offset; // offset_xy
   int m_first_session;	// first session that the root appears
   bool m_still_alive;
};

#endif // !defined(AFX_ROOTOVERTIME_H__EFF4561B_7FB1_4BE2_81CC_0C5B38CB9C96__INCLUDED_)
